#include <CORBA.h>
#include "IPBook.h"

#include <iostream>

using namespace std;

int main( int argc, char **argv)
{
    CORBA::ORB_var orb = CORBA::ORB_init( argc, argv);

    int rc = 0;
    if (argc != 4) {
        cerr << "usage: " << argv[0] << " name number server_address \n";
        exit(1);
    }

    try {
        CORBA::Object_var obj = orb -> bind( "IDL:IPBook:1.0", argv[3]);
        if (CORBA::is_nil( obj)) {
            cerr << "no object at " << argv[3] << " found.\n";
            exit(1);
        }
        IPBook_var f = IPBook::_narrow( obj);
        
        f -> addEntry( argv[1], argv[2]);
    }
    catch(CORBA::SystemException_catch& ex)
    {
        ex -> _print(cerr);
        cerr << endl;
        rc = 1;
    }

    return rc;
}
