#include <CORBA.h>
#include "IPBook.h"

#include <iostream>
#include <fstream>

using namespace std;

int main( int argc, char **argv)
{
    CORBA::ORB_var orb = CORBA::ORB_init( argc, argv);

    int rc = 0;
    if (argc != 2) {
        cerr << "usage: " << argv[0] << " name\n";
        exit(1);
    }

    ifstream in( "IPBook.ref");
    char s[1000];
    in >> s;
    in.close();
    
    try {
        CORBA::Object_var obj = orb -> string_to_object( s);
        IPBook_var f = IPBook::_narrow( obj);

        cout << f -> searchEntry( argv[1]) << endl;
    }
    catch(CORBA::SystemException_catch& ex)
    {
        ex -> _print(cerr);
        cerr << endl;
        rc = 1;
    }

    return rc;
}
