#include <CORBA.h>
#include "IPBook_impl.h"

#include <fstream>

using namespace std;

int main( int argc, char **argv)
{
    int rc = 0;
    
    try {
        // init ORB and POA Manager
        CORBA::ORB_var orb = CORBA::ORB_init( argc, argv);
        CORBA::Object_var poaobj = orb -> resolve_initial_references("RootPOA");
        PortableServer::POA_var poa = PortableServer::POA::_narrow( poaobj);
        PortableServer::POAManager_var mgr = poa -> the_POAManager();

        // create a new instance of the servant
        IPBook_impl *impl = new IPBook_impl;
        // activate the servant
        IPBook_var f = impl -> _this();

        // save the stringified object reference to file
        CORBA::String_var s = orb -> object_to_string( f);
        ofstream out( "IPBook.ref");
        out << s << endl;
        out.close();

        // activate POA manager
        mgr -> activate(); 
        // run the ORB
        orb -> run();
        
        poa -> destroy( TRUE, TRUE);
        delete impl;
        rc = 0;
    }
    catch(CORBA::SystemException_catch& ex)
    {
        ex -> _print(cerr);
        cerr << endl;
        rc = 1;
    }
    return rc;
}
